Index: pjproject/trunk/build.symbian/bld.inf
===================================================================
--- pjproject/trunk/build.symbian/bld.inf	(revision 1792)
+++ pjproject/trunk/build.symbian/bld.inf	(revision 1793)
@@ -16,4 +16,5 @@
 pjsip_ua.mmp
 pjsua_lib.mmp
+libgsmcodec.mmp
 
 pjlib_test.mmp
Index: pjproject/trunk/build.symbian/libgsmcodec.mmp
===================================================================
--- pjproject/trunk/build.symbian/libgsmcodec.mmp	(revision 1793)
+++ pjproject/trunk/build.symbian/libgsmcodec.mmp	(revision 1793)
@@ -0,0 +1,70 @@
+#if defined(PJ_BUILD_DLL)
+
+TARGET		libgsmcodec.dll
+TARGETTYPE	dll
+UID		0x0 0xA000000F
+
+CAPABILITY	None
+LIBRARY		pjlib.lib euser.lib estlib.lib
+MACRO		PJ_DLL
+MACRO		PJ_EXPORTING
+
+DEFFILE		.\libgsmcodec.def
+
+#else
+
+TARGET 		libgsmcodec.lib
+TARGETTYPE 	lib
+
+#endif
+
+//OPTION		CW -lang c++
+
+MACRO		PJ_M_I386=1
+MACRO		PJ_SYMBIAN=1
+
+//
+// GSM codec third party source
+//
+
+SOURCEPATH	..\third_party\gsm\src
+
+SOURCE		add.c
+SOURCE		code.c
+SOURCE		debug.c
+SOURCE		decode.c
+SOURCE		gsm_create.c
+SOURCE		gsm_decode.c
+SOURCE		gsm_destroy.c
+SOURCE		gsm_encode.c
+SOURCE		gsm_explode.c
+SOURCE		gsm_implode.c
+SOURCE		gsm_option.c
+SOURCE		gsm_print.c
+SOURCE		long_term.c
+SOURCE		lpc.c
+SOURCE		preprocess.c
+SOURCE		rpe.c
+SOURCE		short_term.c
+SOURCE		table.c
+
+
+//
+// GSM codec wrapper for pjmedia-codec
+//
+
+SOURCEPATH 	..\pjmedia\src\pjmedia-codec
+SOURCE		gsm.c
+
+//
+// Header files
+//
+
+
+SYSTEMINCLUDE	..\pjmedia\include
+SYSTEMINCLUDE	..\pjlib\include 
+SYSTEMINCLUDE	..\third_party\gsm\inc
+
+SYSTEMINCLUDE	\epoc32\include
+SYSTEMINCLUDE	\epoc32\include\libc
+
Index: pjproject/trunk/build.symbian/symbian_ua.mmp
===================================================================
--- pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 1792)
+++ pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 1793)
@@ -33,4 +33,5 @@
 	LIBRARY		pjnath.lib pjlib_util.lib pjlib.lib
 	LIBRARY		symbian_audio.lib
+	LIBRARY		libgsmcodec.lib
 #else
 	STATICLIBRARY	pjsua_lib.lib pjsip_ua.lib
@@ -38,4 +39,5 @@
 	STATICLIBRARY	pjnath.lib pjlib_util.lib pjlib.lib
 	STATICLIBRARY	symbian_audio.lib
+	STATICLIBRARY	libgsmcodec.lib
 #endif
 
Index: pjproject/trunk/pjlib/include/pj/config_site_sample.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 1792)
+++ pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 1793)
@@ -51,7 +51,7 @@
 #   define PJMEDIA_HAS_SPEEX_AEC	0
 
-    /* Disable all codecs but G.711, for now */
+    /* Disable all codecs but G.711 and GSM, for now */
+#   define PJMEDIA_HAS_GSM_CODEC	1
 #   define PJMEDIA_HAS_L16_CODEC	0
-#   define PJMEDIA_HAS_GSM_CODEC	0
 #   define PJMEDIA_HAS_ILBC_CODEC	0
 #   define PJMEDIA_HAS_SPEEX_CODEC	0
Index: pjproject/trunk/pjsip-apps/src/symbian_ua/ua.cpp
===================================================================
--- pjproject/trunk/pjsip-apps/src/symbian_ua/ua.cpp	(revision 1792)
+++ pjproject/trunk/pjsip-apps/src/symbian_ua/ua.cpp	(revision 1793)
@@ -33,13 +33,13 @@
 // Destination URI (to make call, or to subscribe presence)
 //
-#define SIP_DST_URI	"sip:user@192.168.0.11"
+#define SIP_DST_URI	"sip:100@pjsip.lab"
 
 //
 // Account
 //
-#define HAS_SIP_ACCOUNT	0	// 0 to disable registration
-#define SIP_DOMAIN	"domain"
-#define SIP_USER	"username"
-#define SIP_PASSWD	"password"
+#define HAS_SIP_ACCOUNT	1	// 0 to disable registration
+#define SIP_DOMAIN	"pjsip.lab"
+#define SIP_USER	"400"
+#define SIP_PASSWD	"400"
 
 //
@@ -54,6 +54,6 @@
 // or STUN (for STUN see other settings below)
 //
-#define NAMESERVER	NULL
-//#define NAMESERVER	"192.168.0.1"
+//#define NAMESERVER	NULL
+#define NAMESERVER	"192.168.0.2"
 
 //
@@ -369,5 +369,5 @@
 	cfg.reg_uri = pj_str("sip:" SIP_DOMAIN);
 	cfg.cred_count = 1;
-	cfg.cred_info[0].realm = pj_str(SIP_DOMAIN);
+	cfg.cred_info[0].realm = pj_str("*");
 	cfg.cred_info[0].scheme = pj_str("digest");
 	cfg.cred_info[0].username = pj_str(SIP_USER);